;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Bagels:
	;The Bagels number guessing game
	ld hl,14*256
	ld (pencol),hl
	ld hl,Bagels_Data_Instructions
	call vputstr
	call Game_Pause
	ld hl,14*256
	ld de,63*256+95
	B_CALL ClearRect
	ld hl,14*256
	ld (pencol),hl
	ld hl,Bagels_Data_Instructions_2
	call vputstr
	call Game_Pause
	;Ready to play
Bagels_NewGame:
	B_CALL Random
	ld hl,Bagels_Data_1000
	B_CALL Mov9ToOP2
	B_CALL FPMult
	B_CALL Int
	;Our number is between 0-999
	B_CALL ConvOP1
	;DE is the number
	ex de,hl
	ld de,100
	ld c,-1
Bagels_GetDigit1:
	inc c
	or a
	sbc hl,de
	jr nc,Bagels_GetDigit1
	add hl,de
	ld a,c
	ld (digit1),a
	ld de,10
	ld c,-1
Bagels_GetDigit2:
	inc c
	or a
	sbc hl,de
	jr nc,Bagels_GetDigit2
	add hl,de
	ld a,c
	ld (digit2),a
	ld a,l
	ld (digit3),a
	;Now check if any of the digits are the same
	ld a,(digit1)
	ld b,a
	ld a,(digit2)
	cp b
	jr z,Bagels_NewGame
	ld a,(digit3)
	cp b
	jr z,Bagels_NewGame
	ld b,a
	ld a,(digit2)
	cp b
	jr z,Bagels_NewGame
	;It's a unique number, draw the user interface
	B_CALL ClrLCDFull
	B_CALL GrBufClr
	ld hl,Bagels_Data_Title
	ld de,3*256+26
	call Sprite_Display
	xor a
	ld (numGuesses),a
	ld (guessLen),a
	ld de,57*256
	ld (pencol),de
	ld hl,Bagels_Data_Prompt
	call vputstr
Bagels_MakeGuess_Key:
	B_CALL GetKey
	cp kLeft
	jr z,Bagels_Backspace
	cp kDel
	jr z,Bagels_Backspace
	cp kClear
	jr z,Bagels_Clear
	cp 40h
	jp z,Games
	cp kEnter
	jr z,Bagels_ProcessGuess
	cp 8Eh
	jr c,Bagels_MakeGuess_Key
	cp 98h
	jr nc,Bagels_MakeGuess_Key
	ld b,a
	ld a,(guessLen)
	cp 3
	jr z,Bagels_MakeGuess_Key
	inc a
	ld (guessLen),a
	dec a
	ld e,a
	ld d,0
	ld hl,guess
	add hl,de
	ld a,b
	sub 8Eh
	ld (hl),a
	add a,'0'
	B_CALL VPutMap
	jr Bagels_MakeGuess_Key
Bagels_Backspace:
	ld a,(guessLen)
	or a
	jr z,Bagels_MakeGuess_Key
	dec a
	ld (guessLen),a
	ld a,(pencol)
	sub 4
	ld (pencol),a
	push af
	ld a,6
	B_CALL VPutMap
	pop af
	ld (pencol),a
	jr Bagels_MakeGuess_Key
Bagels_Clear:
	ld a,(guessLen)
	or a
	jp z,Bagels_NewGame
	xor a
	ld (guessLen),a
	ld de,57*256
	ld (pencol),de
	ld hl,Bagels_Data_Prompt
	call vputstr
	ld a,(pencol)
	push af
	ld a,6
	B_CALL VPutMap
	ld a,6
	B_CALL VPutMap
	ld a,6
	B_CALL VPutMap
	pop af
	ld (pencol),a
	jp Bagels_MakeGuess_Key
Bagels_ProcessGuess:
	ld a,(guessLen)
	cp 3
	jp nz,Bagels_MakeGuess_Key
	;Check if it's correct
	ld b,3
	ld hl,digit1
	ld de,guess
Bagels_CheckGuess:
	ld a,(de)
	cp (hl)
	jp nz,Bagels_No
	inc hl
	inc de
	djnz Bagels_CheckGuess
	;It matched!
	;
	ld hl,16*256+20
	ld de,48*256+76
	B_CALL DrawRectBorderClear
	ld de,18*256+22
	ld (pencol),de
	ld hl,Bagels_Data_Correct
	call vputstr
	push hl
	ld a,(numGuesses)
	inc a
	call DispA
	ld de,24*256+22
	ld (pencol),de
	pop hl
	call vputstr
	ld de,34*256+22
	ld (pencol),de
	call vputstr
	ld de,40*256+22
	ld (pencol),de
	call vputstr
	B_CALL GetKey
	cp kEnter
	jp z,Bagels_NewGame
	jp Games
Bagels_Data_Correct:
	DB "You win in ",0
	DB "guesses.",0
	DB "Enter - play",0
	DB "2nd+Quit - exit",0
Bagels_No:
	ld a,(numGuesses)
	cp 3
	jr c,Bagels_Guess_Low
	;Scroll it up
	ld hl,plotsscreen+((16+12)*12)
	ld de,plotsscreen+(16*12)
	ld bc,36*12
	ldir
	B_CALL GrBufCpy
	ld a,2
Bagels_Guess_Low:
	ld b,16
	add a,a
	add a,a
	ld c,a
	add a,a
	add a,c
	add a,b
	ld (penrow),a
	set textWrite,(iy+sGrFlags)
	xor a
	ld (pencol),a
	ld a,(numGuesses)
	inc a
	ld (numGuesses),a
	call DispA
	ld a,'.'
	B_CALL VPutMap
	ld a,' '
	B_CALL VPutMap
	ld a,(guess)
	add a,'0'
	B_CALL VPutMap
	ld a,(guess+1)
	add a,'0'
	B_CALL VPutMap
	ld a,(guess+2)
	add a,'0'
	B_CALL VPutMap
	ld a,(penrow)
	add a,6
	ld (penrow),a
	ld a,10
	ld (pencol),a
	;Display the result
	xor a
	ld b,a
Bagels_Digit_Checks:
	push af
	push bc
	call Bagels_Digit_Check
	jr z,Bagels_Digit_Checks_No
	pop bc
	pop af
	inc b
	inc a
	cp 3
	jr nz,Bagels_Digit_Checks
	jr Bagels_Done
Bagels_Digit_Checks_No:
	pop bc
	pop af
	inc a
	cp 3
	jr nz,Bagels_Digit_Checks
Bagels_Done:
	ld a,b
	cp 3
	call z,Bagels_Bagels
	res textWrite,(iy+sGrFlags)
	B_CALL GrBufCpy
	jp Bagels_Clear
Bagels_Digit_Check:
	;Input - A is the digit place
	ld d,0
	ld e,a
	ld hl,guess
	add hl,de
	ld a,(hl)		;A is the digit of the guess
	ld hl,digit1
	add hl,de
	cp (hl)
	jr z,Bagels_Fermi
	;maybe it is in the wrong place?
	ld hl,digit1
	cp (hl)
	jr z,Bagels_Pico
	inc hl
	cp (hl)
	jr z,Bagels_Pico
	inc hl
	cp (hl)
	ret nz
Bagels_Pico:
	ld hl,Bagels_Data_Pico
	call vputstr
	xor a
	ret
Bagels_Bagels:
	ld hl,Bagels_Data_Bagels
	jp vputstr
Bagels_Fermi:
	ld hl,Bagels_Data_Fermi
	call vputstr
	xor a
	ret
Bagels_Data_Bagels:
	DB "BAGELS",0
Bagels_Data_Pico:
	DB "PICO  ",0
Bagels_Data_Fermi:
	DB "FERMI  ",0
Bagels_Data_Prompt:
	DB "Enter your guess:  ",0
Bagels_Data_1000:
	DB 00h,83h,10h,00h,00h,00h,00h,00h,00h
Bagels_Data_Instructions:
	DB "The computer will pick a",0FFh
	DB "3-digit number using digits",0FFh
	DB "0-9, with no digit repeating.",0FFh
	DB "Ideally you should guess the",0FFh
	DB "number in 8 guesses.",0
Bagels_Data_Instructions_2:
	DB "After a guess you will see:",0FFh
	DB "PICO - 1 digit correct, in",0FFh
	DB "the wrong place",0FFh
	DB "FERMI - 1 digit correct, in",0FFh
	DB "the right place",0FFh
	DB "BAGELS - No digit is correct",0
Bagels_Data_Title:
	DB 9,44
	DB 62,6,15,191,96,240
	DB 127,14,63,190,65,240
	DB 247,30,112,48,193,128
	DB 62,30,96,190,193,192
	DB 63,126,95,188,192,224
	DB 35,127,102,48,192,96
	DB 103,99,126,54,221,32
	DB 126,99,126,62,253,224
	DB 56,0,14,0,1,192
