;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Factorial:
	;Inputs - HL is the number...
	;Output - HL points to the factorial
	;For number n, factorial is n(n-1)(n-2)...1
	;First we should check for 0!
	inc hl
	ld a,(hl)
	dec hl
	bit 7,a
	jp nz,DomainError
	call BCD_CheckZero
	jp z,ReturnOne			;if 0! our answer is going to be 1
	call BCD_Clone
	;Initially, we must copy the number...
	ld c,(hl)
	inc hl
	ld b,(hl)
	res 7,b
	dec hl
	push hl
	ld hl,(areaFreeStart)
	ld (temp8),hl
	inc bc
	inc bc
	add hl,bc
	ld de,(areaFreeEnd)
	or a
	sbc hl,de
	jp nc,MemoryError
	add hl,de
	ld (areaFreeStart),hl
	or a
	sbc hl,bc
	ex de,hl
	pop hl
	push hl
	push de
	ldir
	pop de
	pop hl
	push hl
	call BCD_Decrement
	pop hl
	call BCD_CheckZero		;if n was 1, now it will be 0. If so, then we had 1!
	jp z,ReturnOne
	;HL points to n-1, DE is the original n
	;n-1 is lower in memory than n
	ld (temp9),hl
Factorial_Loop:
	res onInterrupt,(iy+onFlags)
	call BCD_Multiply
	bit onInterrupt,(iy+onFlags)
	jp nz,BreakError
	;HL is our answer...
	push hl
	ld de,(temp8)
	or a
	sbc hl,de
	ex de,hl
	ld hl,(areaFreeStart)
	or a
	sbc hl,de
	ld b,d
	ld c,e
	ld (areaFreeStart),hl
	ld de,(temp8)
	pop hl
	push hl
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	res 7,b
	dec hl
	inc bc
	inc bc
	ldir
	pop bc
	pop hl
	or a
	sbc hl,bc
	;HL now is the answer...
	push hl
	ld hl,(temp9)
	push hl
	call BCD_Decrement
	pop hl
	call BCD_CheckZero
	jr z,Factorial_Done
	pop de
	jr Factorial_Loop
Factorial_Done:
	pop hl
	ret