;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;Math games!
Games:
	res textWrite,(iy+sGrFlags)
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,Games_Data_Title
	ld de,3*256
	call Sprite_Display
	ld bc,16
	ld de,94*256+16
	B_CALL DarkLine
	ld hl,Games_Data_MainHelp
	ld a,50
	ld (penrow),a
	ld a,(hl)
	ld (pencol),a
	inc hl
	call vputstr
	ld e,(hl)
	inc hl
	ld d,57
	ld (pencol),de
	call vputstr
	xor a
	ld (curGame),a
	ld hl,Games_List
	ld a,(hl)
	ld (numGames),a
	call Games_Display
Games_Loop:
	B_CALL GetKey
	cp 40h
	jr z,Games_Exit
	cp kClear
	jr z,Games_Exit
	cp kEnter
	jr z,Games_Select
	cp kEnter
	jr z,Games_Select
	cp kUp
	jr z,Games_Up
 	cp kDown
	jr nz,Games_Loop
	;Down
	ld a,(numGames)
	ld b,a
	ld a,(curGame)
	inc a
	cp b
	jr z,Games_Loop
Games_UpDown:
	ld (curGame),a
	call Games_Display
	jr Games_Loop
Games_Up:
	ld a,(curGame)
	or a
	jr z,Games_Loop
	dec a
	jr Games_UpDown
Games_Select:
	B_CALL ClrLCDFull
 	ld hl,Games_Data_Instructions
	ld de,2*256
	call Sprite_Display
	ld a,(curGame)
	add a,a
	ld d,0
	ld e,a
	ld hl,Games_Data_List
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
Games_Exit:
	jp Interface_Next
Games_Display:
	ld hl,16*256
	ld de,25*256+94
	B_CALL FillRect
	set textInverse,(iy+textFlags)
	ld de,17*256+30
	ld (pencol),de
	ld a,5
	B_CALL VPutMap
	ld a,6
	B_CALL VPutMap
	ld a,(curGame)
	push af
	ld hl,Games_List+1
	call FindString
	call vputstr
	res textInverse,(iy+textFlags)
	ld de,28*256
	ld (pencol),de
	pop af
	ld hl,Games_Descriptions
	call FindString
	jp vputstr
Sprite_Display:
	push de
	ld de,savesscreen
	ld bc,768
	ldir
	ld hl,savesscreen
	pop de
	B_CALL DisplayImage
	ret
FindString:
	or a
	ret z
	ld b,a
FindString_Loop:
	push bc
	ld bc,-1
	xor a
	cpir
	pop bc
	djnz FindString_Loop
	ret
Games_Data_MainHelp:
	DB 8,"Up/Down - Browse Games",0
	DB 20,"Enter - Play Game",0
Games_List:
	DB 1
	DB "Bagels",0
Games_Descriptions:
	DB "Guess the secret number one",0FFh,"digit at a time",0
Games_Data_List:
	DW Bagels
Games_Data_Title:
	DB 10,96
	DB 10h,00h,0Ch,00h,00h,00h,00h,00h,01h,80h,00h,00h
	DB 39h,0EEh,6Ch,39h,0F3h,0F7h,0C0h,3Ch,19h,87h,0BFh,38h
	DB 18h,0DCh,66h,3Dh,0FBh,0F7h,0E0h,0FCh,38h,0C7h,0BEh,7Ch
	DB 1Ch,0CCh,0C6h,3Dh,0BBh,06h,61h,0C0h,78h,0C6h,30h,60h
	DB 1Ch,8Ch,0CEh,71h,0F3h,0E7h,0C1h,80h,0D9h,0CEh,7Eh,70h
	DB 3Eh,98h,0CFh,0F1h,0FBh,0C7h,81h,7Ch,0F9h,0FEh,7Ch,38h
	DB 36h,99h,0CFh,0F1h,1Bh,0Dh,81h,9Dh,0F9h,0FEh,60h,18h
	DB 37h,9Fh,0CDh,0B3h,3Bh,2Dh,0E1h,0F9h,8Dh,0B6h,76h,98h
	DB 33h,0Eh,0ECh,33h,0F3h,0ECh,0E1h,0F9h,0Dh,86h,7Eh,0F8h
	DB 00h,00h,00h,31h,0C0h,0Ch,00h,38h,00h,06h,00h,60h
Games_Data_Instructions:
	DB 10,96
	DB 0,48,0,0,0,0,0,0,0,6,0,0
	DB 15,177,158,253,241,230,60,253,240,230,51,192
	DB 7,25,190,253,249,204,237,253,195,243,55,192
	DB 3,57,176,17,152,204,192,48,207,55,54,0
	DB 6,61,152,49,241,141,128,32,207,55,179,0
	DB 6,61,156,49,225,141,128,97,137,55,179,128
	DB 6,47,142,49,97,153,132,97,140,117,241,192
	DB 6,103,102,51,59,189,220,97,142,236,236,192
	DB 31,99,124,35,56,238,248,99,231,204,111,128
	DB 0,0,56,3,0,0,0,0,0,0,7,0
Game_Pause:
	ld de,57*256+6
	ld (pencol),de
	ld hl,Game_Pause_Data
	call vputstr
	ld hl,56*256
	ld de,63*256+95
	B_CALL InvertRect
	B_CALL RunIndicOn
	ld a,busyPause
	ld (indicBusy),a
	push hl
Game_Pause_Key:
	pop hl
	B_CALL GetKey
	ld hl,Games
	push hl
	cp 40h
	jr z,Game_UndoPause
	cp kEnter
	jr nz,Game_Pause_Key
	pop hl
Game_UndoPause:
	ld a,busyNormal
	ld (indicBusy),a
	B_CALL RunIndicOff
	ret
Game_Pause_Data:
	DB "Press ",0C1h,"ENTER] to continue",0
 INCLUDE "bagels.asm"
