;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;Logarithm function...
;Takes the integer log base b of a
Log:
	;Input - HL points to the number, n
	;DE points to the base, b
	;
	;result = 0; 
   ;while (b <= n) 
   ;{ 
   ;x = b; 
   ;y = 1; 
   ;while (true) 
   ;      {
   ;            temp = x * x;
   ;            if (temp >= n)
   ;                 break;
   ;            x = temp;
   ;            y = y * 2;
   ;       }
   ;       n = n / x;
   ;       result = result + y;
   ;}
	push de
	inc hl
	bit 7,(hl)
	jp nz,DomainError		;No negatives!
	dec hl
	call BCD_CheckZero
	jp z,DomainError		;no zeroes!
	call BCD_Clone
	ld (temp14),hl			;temp14 is n
	pop hl
	inc hl
	bit 7,(hl)
	jp nz,DomainError
	dec hl
	call BCD_CheckZero
	jp z,DomainError
	ld (temp15),hl			;temp15 is b
	call ReturnZero
	ld (temp16),hl			;temp16 is result
Log_LoopStart:
	;Now let's loop until b > n
	ld de,(temp15)
	ld hl,(temp14)
	call BCD_Compare
	jr c,Log_Done
	ld hl,(temp15)
	call BCD_Clone
	ld (temp17),hl			;temp17 is x
	call ReturnOne
	ld (temp18),hl			;temp18 is y
	;Enter nested loop
Log_InnerLoop:
	ld hl,(temp17)
	ld d,h
	ld e,l
	call BCD_Multiply
	ld de,(temp14)
	call BCD_Compare
	jr c,Log_FirstCheckOk
	jr Log_OuterLoop
Log_FirstCheckOk:
	;set x to the multiplied value
	ld (temp17),hl
	;Double y
	ld hl,(temp18)
	ld d,h
	ld e,l
	call BCD_Add
	ld (temp18),hl
	jr Log_InnerLoop
Log_OuterLoop:
	;n=n/x;
	ld hl,(temp14)
	ld de,(temp17)
	call BCD_Division
	ld (temp14),hl
	;result = result + y
	ld hl,(temp16)
	ld de,(temp18)
	call BCD_Add
	ld (temp16),hl
	jr Log_LoopStart
Log_Done:
	ld hl,(temp16)
	ret
